package de.fhswf;

import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.text.MaskFormatter;

/**
 * 
 * Fahrer-Klasse, um neue Fahrer ber das Men anzulegen.
 *
 * @author $Author:  Thomas Kramer
 * @version $Revision:  $, $Date:  03.12.2012 UTC
 */
public class DriverFrame extends JDialog
{
   private JFormattedTextField fkTextField = null;
   private JFormattedTextField fsTextField = null;   
   /**
    * 
    * Konstruktor
    *
    */
   public DriverFrame(JFrame owner)
   {
      super(owner, "Anlegen eines neuen Fahrers");
      setLayout(null);     
      setSize(600, 300);
      
      /**
       * Generieren aller Labels und Buttons
       */
      JLabel dNLabel = new JLabel("Name des Fahrers");
      dNLabel.setBounds(20, 5, 200, 30);
      add(dNLabel);
      final JTextField dNTextField = new JTextField(0);
      dNTextField.setBounds(210, 5, 200, 30);
      add(dNTextField);
      
      MaskFormatter formatter;                
      
      JLabel fkLabel = new JLabel("Fhrerscheinklasse");          
      fkLabel.setBounds(20, 35, 200, 30);
      add(fkLabel);
      JLabel fsLabel = new JLabel("FhrerscheinSeit");
      fsLabel.setBounds(20, 65, 200, 30);
      add(fsLabel);
      
      /**
       * Speziell formatierte Eingabefelder erzeugen
       */      
      try
      {
         // ? fr beliebige Zahl, # fr beliebiges Zeichen
         // siehe http://www.tutego.de/blog/javainsel/2010/04/formatieren-mit-masken-der-maskformatter/
         formatter = new MaskFormatter("?#");
         formatter.setValidCharacters("ABCDE123");
         fkTextField = new JFormattedTextField(formatter);         
         fkTextField.setBounds(210, 35, 200, 30);
         add(fkTextField);
         
         formatter = new MaskFormatter("##.##.####");
         formatter.setValidCharacters("0123456789");
         fsTextField = new JFormattedTextField(formatter);         
         fsTextField.setBounds(210, 65, 200, 30);
         add(fsTextField);         
      }
      catch (ParseException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
            
      JLabel fg1 = new JLabel("1. Fahrzeug:");
      fg1.setBounds(20, 140, 200, 30);
      add(fg1);
      final JComboBox fg1CB = new JComboBox();
      fg1CB.setBounds(210, 140, 200, 30);
      add(fg1CB);            
      JLabel fg2 = new JLabel("2. Fahrzeug:");
      fg2.setBounds(20, 170, 200, 30);
      add(fg2);  
      final JComboBox fg2CB = new JComboBox();
      fg2CB.setBounds(210, 170, 200, 30);
      add(fg2CB);                
      JLabel fg3 = new JLabel("3. Fahrzeug:");
      fg3.setBounds(20, 200, 200, 30);
      add(fg3);      
      final JComboBox fg3CB = new JComboBox();
      fg3CB.setBounds(210, 200, 200, 30);
      add(fg3CB);
      
      JButton saveButton = new JButton("Speichern");
      saveButton.setBounds(470, 80, 100, 30);
      add(saveButton);
      saveButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  boolean failure = false;
                  
                  /**
                   * Fehlerberprfung
                   */
                  failure = dNTextField.getText().trim().equals("");
                  failure = failure || (((String) fkTextField.getText()).trim().equals(("")));
                  failure = failure || (((String) fsTextField.getText()).trim().equals(("")));                  
                  failure = failure || (((String) fg1CB.getSelectedItem()).trim().equals(("")));                  
                  failure = failure || (((String) fg1CB.getSelectedItem()).equals(((String) fg2CB.getSelectedItem())));
                  failure = failure || (((String) fg2CB.getSelectedItem()).equals(((String) fg3CB.getSelectedItem()))
                                        && !((String) fg2CB.getSelectedItem()).equals(""));                  
                  
                  /**
                   * wenn Fehler aufgetreten ist.... ansonsten speichern
                   */
                  if (failure)
                  {
                     JOptionPane
                     .showMessageDialog(
                           null,
                           "Es mssen mindestens ein Fahrername und ein Auto gespeichert werden - weitere Autos mssen unterschiedlich sein!",
                           "Fehler",
                           JOptionPane.ERROR_MESSAGE);
                  } else {
                     /**
                      * Speichern eines neuen Fahrers
                      */
                     DataBaseHelper.insertNewDriver(dNTextField.getText().trim(), 
                           fkTextField.getText().trim(), 
                           fsTextField.getText().trim());
                     
                     /**
                      * Speichern einer neuen Zustndigkeit
                      */
                     DataBaseHelper.insertNewAssociation(
                           (String) dNTextField.getText().trim(), 
                           ((String) fg1CB.getSelectedItem()).trim(), 
                           ((String) fg2CB.getSelectedItem()).trim(), 
                           ((String) fg3CB.getSelectedItem()).trim()
                           );
                                          
                     /**
                      * Erfolgsmeldung ausgeben
                      */
                     JOptionPane
                     .showMessageDialog(
                           null,
                           "Es wurde ein neuer Fahrer mitsamt Fahrerzuordnung angelegt!",
                           "Information",
                           JOptionPane.INFORMATION_MESSAGE);
                     
                     /**
                      * Daten aktualisieren
                      */
                     //Main.mainFrame.driver.doClick();
                     Main.mainFrame.associations.doClick();
                     dispose();                                          
                  }
               }
            });
         }
      });            
      
      JButton closeButton = new JButton("Schlieen");
      closeButton.setBounds(470, 120, 100, 30);
      add(closeButton);
      closeButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  dispose();
               }
            });
         }
      });
      
      /**
       * Fllen der Comboboxen mit Daten
       */
      DataBaseHelper.fillCarsComboboxes(fg1CB);
      DataBaseHelper.fillCarsComboboxes(fg2CB);
      DataBaseHelper.fillCarsComboboxes(fg3CB);      
      
      // positionieren des Fensters: mittig
      setLocationRelativeTo(null);      
   }
}
